---
#tasks file for ansible-role-docker
- name: Docker remove old package
  ansible.builtin.package:
    name:
      - docker.io
      - docker-doc
      - docker-compose
      - docker-compose-v2
      - podman-docker
      - containerd
      - runc
    state: absent
  when: docker_file is exists
  vars:
    docker_file: "/usr/bin/docker"
  tags: docker_remove
    
- name: Docker check if install need packages for virtualization
  ansible.builtin.package:
    name: 
      - "gnupg"
      - "ca-certificates"
      - "systemd"
    state: present
  when: "ansible_facts.virtualization_type == 'docker'"
  tags:
    - docker_install
    - docker_install_for_docker
    
- name: Docker check keyring dir exests
  ansible.builtin.file:
    path: /etc/apt/keyrings
    mode: 0755
    state: directory
    owner: root
    group: root
  tags:
    - docker_install
  
- name: Docker add APT key
  ansible.builtin.apt_key:
    url:  "{{ docker_gpg.url }}/gpg"
    keyring: "{{ docker_gpg.path }}"
  tags:
    - docker_install

- name: Docker add repository
  ansible.builtin.apt_repository:
    repo: "deb [arch=amd64 signed-by={{ docker_gpg.path }}] {{ docker_gpg.url }} {{ ansible_distribution_release }} stable"
    state: present
    update_cache: true
  tags:
    - docker_install
    
- name: Docker install all need packages for docker
  ansible.builtin.package:
    name: 
      - docker-ce   
      - docker-ce-cli
      - containerd.io
      - docker-buildx-plugin
      - docker-compose-plugin
      - python3-pip
    state: present
    update_cache: true
  tags:
    - docker_install
       
- name: Docker check is that docker container for change ulimit
  ansible.builtin.lineinfile:
    path: /etc/init.d/docker
    regexp: '^(\s+)ulimit -Hn 524288'
    line: "{{ (' ' * 16) }}ulimit -n 524288"
  when: "ansible_facts.virtualization_type == 'docker'"
  notify: docker_start
  tags:
    - docker_install
  
- name: Docker start service
  ansible.builtin.assert:
    that:
      - ansible_facts.virtualization_type != 'docker'
    quiet: true
  when: "ansible_facts.virtualization_type != 'docker'"
  notify: docker_start
  tags:
    - docker_install

- name: Docker Install pip docker
  become: no
  ansible.builtin.pip:
    name: 
      - docker
      - docker-compose
  tags:
    - docker_install
    - docker_install_pip
      
- name: Docker add user to docker group
  ansible.builtin.user:
    name: "{{ docker_ssh_user }}"
    groups: docker
  when: docker_ssh_user
  tags:
    - docker_install
    - docker_conpose
    - docker_container

- name: Docker login in registry
  community.docker.docker_login:
    registry_url: "{{ docker_registry.url }}"
    username: "{{ docker_registry.user | default('gitlab-ci-token') }}"
    password: "{{ docker_registry.password }}"
    reauthorize: true
  when: docker_registry_login
  tags:
    - docker_install
    - docker_conpose
    - docker_container

- name: Docker cron for clean unused resource
  ansible.builtin.cron:
    name: "docker prune"
    hour: "0"
    job: "docker system prune -af"
  when: docker_cron_prune
  tags:
    - docker_install
    - docker_cron

- import_tasks: container.yml
  when: docker_container_start
  tags:
    - docker_container
  
- import_tasks: compose.yml
  when: docker_compose_start
  tags:
    - docker_conpose

- import_tasks: hosts.yml
  when: docker_to_hosts
  tags:
    - docker_to_hosts
    - docker_container
    - docker_conpose
  
